package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTExpressionList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTExpressionList extends JNIObject  {
	
	/* @generated */
	protected ISLASTExpressionList(long ptr) {
		/*** PROTECTED REGION ID(ISLASTExpressionList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLASTExpressionList build(long ptr) {
		return new ISLASTExpressionList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLASTExpressionList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_ast_expr_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLASTExpressionList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_list_alloc) DISABLED START ***/
		ISLASTExpressionList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTExpressionList.build(ISLNative.isl_ast_expr_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_expr_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_ast_expr_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_ast_expr_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_list_copy 
	 * 
	 * @generated
	**/
	public ISLASTExpressionList copy() {
		/*** PROTECTED REGION ID(isl_ast_expr_list_copy) DISABLED START ***/
		ISLASTExpressionList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTExpressionList.build(ISLNative.isl_ast_expr_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_ast_expr_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_ast_expr_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_list_n_ast_expr 
	 * 
	 * @generated
	**/
	public int getNbNodes() {
		/*** PROTECTED REGION ID(isl_ast_expr_list_n_ast_expr) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_ast_expr_list_n_ast_expr(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_list_get_ast_expr 
	 * 
	 * @generated
	**/
	public ISLASTExpression get(int index) {
		/*** PROTECTED REGION ID(isl_ast_expr_list_get_ast_expr) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_expr_list_get_ast_expr(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_list_set_ast_expr 
	 * 
	 * @take this expr
	 * @generated
	**/
	public ISLASTExpressionList set(int index, ISLASTExpression expr) {
		/*** PROTECTED REGION ID(isl_ast_expr_list_set_ast_expr) DISABLED START ***/
		ISLASTExpressionList res;
		
		synchronized(LOCK) {
			checkParameters(this, expr);
			try {
				res = ISLASTExpressionList.build(ISLNative.isl_ast_expr_list_set_ast_expr(getNativePtr(this), index, getNativePtr(expr)));
			} finally {
				taken(this);
				taken(expr);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLASTExpressionList insert(int pos, ISLASTExpression el) {
		/*** PROTECTED REGION ID(isl_ast_expr_list_insert) DISABLED START ***/
		ISLASTExpressionList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLASTExpressionList.build(ISLNative.isl_ast_expr_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLASTExpressionList add(ISLASTExpression el) {
		/*** PROTECTED REGION ID(isl_ast_expr_list_add) DISABLED START ***/
		ISLASTExpressionList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLASTExpressionList.build(ISLNative.isl_ast_expr_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLASTExpressionList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_ast_expr_list_drop) DISABLED START ***/
		ISLASTExpressionList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLASTExpressionList.build(ISLNative.isl_ast_expr_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLASTExpressionList concat(ISLASTExpressionList list2) {
		/*** PROTECTED REGION ID(isl_ast_expr_list_concat) DISABLED START ***/
		ISLASTExpressionList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLASTExpressionList.build(ISLNative.isl_ast_expr_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTExpressionList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
